Index: sasmodels/models/lamellarCailleHG.py
===================================================================
--- sasmodels/models/lamellarCailleHG.py	(revision d18f8a8e10d65f0ace6fdc9360abd60dfcd6dcce)
+++ sasmodels/models/lamellarCailleHG.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -91,26 +91,27 @@
 category = "shape:lamellae"
 
+single = False
 parameters = [
-              #   [ "name", "units", default, [lower, upper], "type",
-              #     "description" ],
-              [ "tail_length", "Ang",  10, [0, inf], "volume",
-                "Tail thickness" ],
-              [ "head_length", "Ang",  2, [0, inf], "volume",
-                "head thickness" ],
-              [ "Nlayers", "",  30, [0, inf], "",
-                "Number of layers" ],
-              [ "spacing", "Ang", 40., [0.0,inf], "volume",
-                "d-spacing of Caille S(Q)" ],
-              [ "Caille_parameter", "", 0.001, [0.0,0.8], "",
-                "Caille parameter" ],
-              [ "sld", "1e-6/Ang^2", 0.4, [-inf,inf], "",
-                "Tail scattering length density" ],
-              [ "head_sld", "1e-6/Ang^2", 2.0, [-inf,inf], "",
-                "Head scattering length density" ],
-              [ "solvent_sld", "1e-6/Ang^2", 6, [-inf,inf], "",
-                "Solvent scattering length density" ],
+    #   [ "name", "units", default, [lower, upper], "type",
+    #     "description" ],
+    ["tail_length", "Ang", 10, [0, inf], "volume",
+     "Tail thickness"],
+    ["head_length", "Ang", 2, [0, inf], "volume",
+     "head thickness"],
+    ["Nlayers", "", 30, [0, inf], "",
+     "Number of layers"],
+    ["spacing", "Ang", 40., [0.0, inf], "volume",
+     "d-spacing of Caille S(Q)"],
+    ["Caille_parameter", "", 0.001, [0.0, 0.8], "",
+     "Caille parameter"],
+    ["sld", "1e-6/Ang^2", 0.4, [-inf, inf], "",
+     "Tail scattering length density"],
+    ["head_sld", "1e-6/Ang^2", 2.0, [-inf, inf], "",
+     "Head scattering length density"],
+    ["solvent_sld", "1e-6/Ang^2", 6, [-inf, inf], "",
+     "Solvent scattering length density"],
     ]
 
-source = [ "lamellarCailleHG_kernel.c"]
+source = ["lamellarCailleHG_kernel.c"]
 
 # No volume normalization despite having a volume parameter
@@ -128,15 +129,24 @@
 
 demo = dict(
-            scale=1, background=0,
-            Nlayers=20,
-            spacing=200., Caille_parameter=0.05,
-            tail_length=15,head_length=10,
-            #sld=-1, head_sld=4.0, solvent_sld=6.0,
-            sld=-1, head_sld=4.1, solvent_sld=6.0,
-            tail_length_pd= 0.1, tail_length_pd_n=20,
-            head_length_pd= 0.05, head_length_pd_n=30,
-            spacing_pd= 0.2, spacing_pd_n=40
-           )
+    scale=1, background=0,
+    Nlayers=20, spacing=200., Caille_parameter=0.05,
+    tail_length=15, head_length=10,
+    #sld=-1, head_sld=4.0, solvent_sld=6.0,
+    sld=-1, head_sld=4.1, solvent_sld=6.0,
+    tail_length_pd=0.1, tail_length_pd_n=20,
+    head_length_pd=0.05, head_length_pd_n=30,
+    spacing_pd=0.2, spacing_pd_n=40,
+    )
 
 oldname = 'LamellarPSHGModel'
-oldpars = dict(tail_length='deltaT',head_length='deltaH',Nlayers='n_plates',Caille_parameter='caille', sld='sld_tail', head_sld='sld_head',solvent_sld='sld_solvent')
+
+oldpars = dict(
+    tail_length='deltaT', head_length='deltaH', Nlayers='n_plates',
+    Caille_parameter='caille', sld='sld_tail', head_sld='sld_head',
+    solvent_sld='sld_solvent')
+#
+tests = [
+        [ {'scale': 1.0, 'background' : 0.0, 'tail_length' : 10.0, 'head_length' : 2.0,'Nlayers' : 30.0, 'spacing' : 40.,
+            'Caille_parameter' : 0.001, 'sld' : 0.4, 'head_sld' : 2.0, 'solvent_sld' : 6.0,
+            'tail_length_pd' : 0.0, 'head_length_pd' : 0.0, 'spacing_pd' : 0.0 }, [0.001], [6838238.571488]]
+        ]
Index: sasmodels/models/lamellarFFHG.py
===================================================================
--- sasmodels/models/lamellarFFHG.py	(revision eb69cce00f0781ad8f3eec0eb5965a8576d815b5)
+++ sasmodels/models/lamellarFFHG.py	(revision 7f47777b1828197366e17d650a92f794a3433fcc)
@@ -121,3 +121,9 @@
 oldpars = dict(head_length='h_thickness', tail_length='t_length',
                sld='sld_tail', head_sld='sld_head', solvent_sld='sld_solvent')
+#
+tests = [
+        [ {'scale': 1.0, 'background' : 0.0, 'tail_length' : 15.0, 'head_length' : 10.0,'sld' : 0.4,
+         'head_sld' : 3.0, 'solvent_sld' : 6.0, }, [0.001], [653143.9209]]
+        ]
 
+
Index: sasmodels/models/lamellarPC.py
===================================================================
--- sasmodels/models/lamellarPC.py	(revision d18f8a8e10d65f0ace6fdc9360abd60dfcd6dcce)
+++ sasmodels/models/lamellarPC.py	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -111,4 +111,6 @@
 category = "shape:lamellae"
 
+single = False
+
 #             ["name", "units", default, [lower, upper], "type","description"],
 parameters = [["thickness", "Ang", 33.0, [0, inf], "volume",
@@ -148,2 +150,8 @@
 oldpars = dict(spacing_polydisp='pd_spacing', sld='sld_layer',
                solvent_sld='sld_solvent')
+#
+tests = [
+        [ {'scale': 1.0, 'background' : 0.0, 'thickness' : 33.,'Nlayers' : 20.0, 'spacing' : 250., 'spacing_polydisp' : 0.2,
+            'sld' : 1.0, 'solvent_sld' : 6.34,
+            'thickness_pd' : 0.0, 'thickness_pd_n' : 40 }, [0.001, 0.215268], [21829.3, 0.00487686]]
+        ]
Index: sasmodels/models/lib/Si.c
===================================================================
--- sasmodels/models/lib/Si.c	(revision 7d256c8e17a297791fce97bf345d7fc77d503e10)
+++ sasmodels/models/lib/Si.c	(revision f12357fd54eaa1b861fbe7a32191f62f1f1d5afd)
@@ -13,6 +13,6 @@
 
 		// Explicitly writing factorial values triples the speed of the calculation
-		out_cos = 1/x - 2/pow(x,3) + 24/pow(x,5) - 720/pow(x,7) + 40320/pow(x,9);
-		out_sin = 1/x - 6/pow(x,4) + 120/pow(x,6) - 5040/pow(x,8) + 362880/pow(x,10);
+		out_cos = 1./x - 2./pow(x,3) + 24./pow(x,5) - 720./pow(x,7);
+		out_sin = 1./pow(x,2) - 6./pow(x,4) + 120./pow(x,6) - 5040./pow(x,8);
 
 		out -= cos(x) * out_cos;
@@ -22,7 +22,6 @@
 
 	// Explicitly writing factorial values triples the speed of the calculation
-	out = x - pow(x, 3)/18 + pow(x,5)/600 - pow(x,7)/35280 + pow(x,9)/3265920;
+	out = x - pow(x, 3)/18. + pow(x,5)/600. - pow(x,7)/35280. + pow(x,9)/3265920. - pow(x,11)/439084800.;
 
-	//printf ("Si=%g %g\n", x, out);
 	return out;
 }
Index: sasmodels/models/lib/gfn.c
===================================================================
--- sasmodels/models/lib/gfn.c	(revision 177c1a138481a9833b4929af687e86583b5c16d5)
+++ sasmodels/models/lib/gfn.c	(revision 177c1a138481a9833b4929af687e86583b5c16d5)
@@ -0,0 +1,36 @@
+//
+//     FUNCTION gfn4:    CONTAINS F(Q,A,B,MU)**2  AS GIVEN
+//                       BY (53) & (58-59) IN CHEN AND
+//                       KOTLARCHYK REFERENCE
+//
+//       <OBLATE ELLIPSOID>
+// function gfn4 for oblate ellipsoids
+double
+gfn4(double xx, double crmaj, double crmin, double trmaj, double trmin, double delpc, double delps, double qq);
+double
+gfn4(double xx, double crmaj, double crmin, double trmaj, double trmin, double delpc, double delps, double qq)
+{
+    // local variables
+    const double pi43=4.0/3.0*M_PI;
+    const double aa = crmaj;
+    const double bb = crmin;
+    const double u2 = (bb*bb*xx*xx + aa*aa*(1.0-xx*xx));
+    const double uq = sqrt(u2)*qq;
+    // changing to more accurate sph_j1c since the following inexplicably fails on Radeon Nano.
+    //const double siq = (uq == 0.0 ? 1.0 : 3.0*(sin(uq)/uq/uq - cos(uq)/uq)/uq);
+    const double siq = sph_j1c(uq);
+    const double vc = pi43*aa*aa*bb;
+    const double gfnc = siq*vc*delpc;
+
+    const double ut2 = (trmin*trmin*xx*xx + trmaj*trmaj*(1.0-xx*xx));
+    const double ut= sqrt(ut2)*qq;
+    const double vt = pi43*trmaj*trmaj*trmin;
+    //const double sit = (ut == 0.0 ? 1.0 : 3.0*(sin(ut)/ut/ut - cos(ut)/ut)/ut);
+    const double sit = sph_j1c(ut);
+    const double gfnt = sit*vt*delps;
+
+    const double tgfn = gfnc + gfnt;
+    const double result = tgfn*tgfn;
+
+    return (result);
+}
Index: sasmodels/models/lib/sph_j1c.c
===================================================================
--- sasmodels/models/lib/sph_j1c.c	(revision 9c461c713e9961727442c844be3e6354d6548c2f)
+++ sasmodels/models/lib/sph_j1c.c	(revision a3e78c304bba2ffdbd8ad1b8da217f22e084346c)
@@ -1,4 +1,4 @@
 /**
-* Spherical Bessel function j1(x)/x
+* Spherical Bessel function 3*j1(x)/x
 *
 * Used for low q to avoid cancellation error.
@@ -8,4 +8,9 @@
 * requires the first 3 terms.  Double precision requires the 4th term.
 * The fifth term is not needed, and is commented out.
+* Taylor expansion:
+*      1.0 + q2*(-3./30. + q2*(3./840.))+ q2*(-3./45360. + q2*(3./3991680.))))
+* Expression returned from Herbie (herbie.uwpise.org/demo):
+*      const double t = ((1. + 3.*q2*q2/5600.) - q2/20.);
+*      return t*t;
 */
 
@@ -18,8 +23,23 @@
     SINCOS(q, sin_q, cos_q);
 
-    const double bessel = (q < 1.e-1) ?
-        1.0 + q2*(-3./30. + q2*(3./840. + q2*(-3./45360.))) // + q2*(3./3991680.)))
+    const double bessel = (q < 0.384038453352533)
+        ? (1.0 + q2*(-3./30. + q2*(3./840.)))
         : 3.0*(sin_q/q - cos_q)/q2;
 
     return bessel;
+
+ /*
+    // Code to test various expressions
+    if (sizeof(q2) > 4) {
+        return 3.0*(sin_q/q - cos_q)/q2;
+    } else if (q < 0.384038453352533) {
+        //const double t = ((1. + 3.*q2*q2/5600.) - q2/20.); return t*t;
+        return 1.0 + q2*q2*(3./840.) - q2*(3./30.);
+        //return 1.0 + q2*(-3./30. + q2*(3./840.));
+        //return 1.0 + q2*(-3./30. + q2*(3./840. + q2*(-3./45360.)));
+        //return 1.0 + q2*(-3./30. + q2*(3./840. + q2*(-3./45360. + q2*(3./3991680.))));
+    } else {
+        return 3.0*(sin_q/q - cos_q)/q2;
+    }
+*/
 }
Index: sasmodels/models/lib/wrc_cyl.c
===================================================================
--- sasmodels/models/lib/wrc_cyl.c	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
+++ sasmodels/models/lib/wrc_cyl.c	(revision 13ed84c3c71257d2df9c2ed4b4e98c0bfa4d7d69)
@@ -0,0 +1,434 @@
+/*
+    Functions for WRC implementation of flexible cylinders
+*/
+static double
+AlphaSquare(double x)
+{
+    return pow( (1.0 + (x/3.12)*(x/3.12) +
+         (x/8.67)*(x/8.67)*(x/8.67)),(0.176/3.0) );
+}
+
+//
+static double
+Rgsquarezero(double q, double L, double b)
+{
+    return (L*b/6.0) * (1.0 - 1.5*(b/L) + 1.5*pow((b/L),2) -
+         0.75*pow((b/L),3)*(1.0 - exp(-2.0*(L/b))));
+}
+
+//
+static double
+Rgsquareshort(double q, double L, double b)
+{
+    return AlphaSquare(L/b) * Rgsquarezero(q,L,b);
+}
+
+//
+static double
+Rgsquare(double q, double L, double b)
+{
+    return AlphaSquare(L/b)*L*b/6.0;
+}
+
+static double
+sech_WR(double x)
+{
+    return(1/cosh(x));
+}
+
+static double
+a1long(double q, double L, double b, double p1, double p2, double q0)
+{
+    double yy,C,C1,C2,C3,C4,C5,miu,Rg2;
+    double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,t14,t15;
+    double E,pi;
+    double b2,b3,b4,q02,q03,q04,q05,Rg22;
+
+    pi = 4.0*atan(1.0);
+    E = 2.718281828459045091;
+
+    if( L/b > 10.0) {
+        C = 3.06/pow((L/b),0.44);
+    } else {
+        C = 1.0;
+    }
+
+    C1 = 1.22;
+    C2 = 0.4288;
+    C3 = -1.651;
+    C4 = 1.523;
+    C5 = 0.1477;
+    miu = 0.585;
+
+    Rg2 = Rgsquare(q,L,b);
+    Rg22 = Rg2*Rg2;
+    b2 = b*b;
+    b3 = b*b*b;
+    b4 = b3*b;
+    q02 = q0*q0;
+    q03 = q0*q0*q0;
+    q04 = q03*q0;
+    q05 = q04*q0;
+
+    t1 = (b*C*((4.0/15.0 - pow(E,(-((q02*Rg2)/b2)))*((11.0/15.0 +
+        (7.0*b2)/(15.0*q02*Rg2))) + (7.0*b2)/(15.0*q02*Rg2))));
+
+    t2 = (2.0*b4*(((-1.0) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*((1.0 + 1.0/2.0*(((-1.0) -
+        tanh(((-C4) + (sqrt(Rg2)*q0)/b)/C5))))));
+
+    t3 = ((C3*pow((((sqrt(Rg2)*q0)/b)),((-3.0)/miu)) +
+        C2*pow((((sqrt(Rg2)*q0)/b)),((-2.0)/miu)) +
+        C1*pow((((sqrt(Rg2)*q0)/b)),((-1.0)/miu))));
+
+    t4 = ((1.0 + tanh(((-C4) + (sqrt(Rg2)*q0)/b)/C5)));
+
+    t5 = (1.0/(b*p1*pow(q0,((-1.0) - p1 - p2)) -
+        b*p2*pow(q0,((-1.0) - p1 - p2))));
+
+    t6 = (b*C*(((-((14.0*b3)/(15.0*q03*Rg2))) +
+        (14.0*b3*pow(E,(-((q02*Rg2)/b2))))/(15.0*q03*Rg2) +
+        (2.0*pow(E,(-((q02*Rg2)/b2)))*q0*((11.0/15.0 +
+        (7.0*b2)/(15.0*q02*Rg2)))*Rg2)/b)));
+
+    t7 = (sqrt(Rg2)*((C3*pow((((sqrt(Rg2)*q0)/b)),((-3.0)/miu)) +
+        C2*pow((((sqrt(Rg2)*q0)/b)),((-2.0)/miu)) +
+        C1*pow((((sqrt(Rg2)*q0)/b)),((-1.0)/miu))))*pow(sech_WR(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5),2));
+
+    t8 = (b4*sqrt(Rg2)*(((-1.0) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*pow(sech_WR(((-C4) + (sqrt(Rg2)*q0)/b)/C5),2));
+
+    t9 = (2.0*b4*(((2.0*q0*Rg2)/b -
+        (2.0*pow(E,(-((q02*Rg2)/b2)))*q0*Rg2)/b))*((1.0 + 1.0/2.0*(((-1.0) -
+        tanh(((-C4) + (sqrt(Rg2)*q0)/b)/C5))))));
+
+    t10 = (8.0*b4*b*(((-1.0) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*((1.0 + 1.0/2.0*(((-1.0) - tanh(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5))))));
+
+    t11 = (((-((3.0*C3*sqrt(Rg2)*pow((((sqrt(Rg2)*q0)/b)),((-1.0) -
+        3.0/miu)))/miu)) - (2.0*C2*sqrt(Rg2)*pow((((sqrt(Rg2)*q0)/b)),((-1.0) -
+        2.0/miu)))/miu - (C1*sqrt(Rg2)*pow((((sqrt(Rg2)*q0)/b)),((-1.0) -
+        1.0/miu)))/miu));
+
+    t12 = ((1.0 + tanh(((-C4) + (sqrt(Rg2)*q0)/b)/C5)));
+
+    t13 = (b*C*((4.0/15.0 - pow(E,(-((q02*Rg2)/b2)))*((11.0/15.0 +
+        (7.0*b2)/(15.0*q02* Rg2))) +
+        (7.0*b2)/(15.0*q02*Rg2))));
+
+    t14 = (2.0*b4*(((-1.0) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*((1.0 + 1.0/2.0*(((-1.0) - tanh(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5))))));
+
+    t15 = ((C3*pow((((sqrt(Rg2)*q0)/b)),((-3.0)/miu)) +
+        C2*pow((((sqrt(Rg2)*q0)/b)),((-2.0)/miu)) +
+        C1*pow((((sqrt(Rg2)*q0)/b)),((-1.0)/miu))));
+
+
+    yy = (pow(q0,p1)*(((-((b*pi)/(L*q0))) +t1/L +t2/(q04*Rg22) +
+        1.0/2.0*t3*t4)) + (t5*((pow(q0,(p1 - p2))*
+        (((-pow(q0,(-p1)))*(((b2*pi)/(L*q02) +t6/L +t7/(2.0*C5) -
+        t8/(C5*q04*Rg22) + t9/(q04*Rg22) -t10/(q05*Rg22) + 1.0/2.0*t11*t12)) -
+        b*p1*pow(q0,((-1.0) - p1))*(((-((b*pi)/(L*q0))) + t13/L +
+        t14/(q04*Rg22) + 1.0/2.0*t15*((1.0 + tanh(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5)))))))))));
+
+    return (yy);
+}
+
+static double
+a2long(double q, double L, double b, double p1, double p2, double q0)
+{
+    double yy,C1,C2,C3,C4,C5,miu,C,Rg2;
+    double t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,pi;
+    double E,b2,b3,b4,q02,q03,q04,q05,Rg22;
+
+    pi = 4.0*atan(1.0);
+    E = 2.718281828459045091;
+    if( L/b > 10.0) {
+        C = 3.06/pow((L/b),0.44);
+    } else {
+        C = 1.0;
+    }
+
+    C1 = 1.22;
+    C2 = 0.4288;
+    C3 = -1.651;
+    C4 = 1.523;
+    C5 = 0.1477;
+    miu = 0.585;
+
+    Rg2 = Rgsquare(q,L,b);
+    Rg22 = Rg2*Rg2;
+    b2 = b*b;
+    b3 = b*b*b;
+    b4 = b3*b;
+    q02 = q0*q0;
+    q03 = q0*q0*q0;
+    q04 = q03*q0;
+    q05 = q04*q0;
+
+    t1 = (1.0/(b* p1*pow(q0,((-1.0) - p1 - p2)) -
+        b*p2*pow(q0,((-1.0) - p1 - p2)) ));
+
+    t2 = (b*C*(((-1.0*((14.0*b3)/(15.0*q03*Rg2))) +
+        (14.0*b3*pow(E,(-((q02*Rg2)/b2))))/(15.0*q03*Rg2) +
+        (2.0*pow(E,(-((q02*Rg2)/b2)))*q0*((11.0/15.0 +
+        (7*b2)/(15.0*q02*Rg2)))*Rg2)/b)))/L;
+
+    t3 = (sqrt(Rg2)*((C3*pow((((sqrt(Rg2)*q0)/b)),((-3.0)/miu)) +
+        C2*pow((((sqrt(Rg2)*q0)/b)),((-2.0)/miu)) +
+        C1*pow((((sqrt(Rg2)*q0)/b)),((-1.0)/miu))))*
+        pow(sech_WR(((-C4) +(sqrt(Rg2)*q0)/b)/C5),2.0))/(2.0*C5);
+
+    t4 = (b4*sqrt(Rg2)*(((-1.0) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*pow(sech_WR(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5),2))/(C5*q04*Rg22);
+
+    t5 = (2.0*b4*(((2.0*q0*Rg2)/b -
+        (2.0*pow(E,(-((q02*Rg2)/b2)))*q0*Rg2)/b))*
+        ((1.0 + 1.0/2.0*(((-1.0) - tanh(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5))))))/(q04*Rg22);
+
+    t6 = (8.0*b4*b*(((-1.0) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*((1.0 + 1.0/2.0*(((-1) - tanh(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5))))))/(q05*Rg22);
+
+    t7 = (((-((3.0*C3*sqrt(Rg2)*pow((((sqrt(Rg2)*q0)/b)),((-1.0) -
+        3.0/miu)))/miu)) - (2.0*C2*sqrt(Rg2)*pow((((sqrt(Rg2)*q0)/b)),
+        ((-1.0) - 2.0/miu)))/miu - (C1*sqrt(Rg2)*pow((((sqrt(Rg2)*q0)/b)),
+        ((-1.0) - 1.0/miu)))/miu));
+
+    t8 = ((1.0 + tanh(((-C4) + (sqrt(Rg2)*q0)/b)/C5)));
+
+    t9 = (b*C*((4.0/15.0 - pow(E,(-((q02*Rg2)/b2)))*((11.0/15.0 +
+        (7.0    *b2)/(15*q02*Rg2))) + (7.0*b2)/(15.0*q02*Rg2))))/L;
+
+    t10 = (2.0*b4*(((-1) + pow(E,(-((q02*Rg2)/b2))) +
+        (q02*Rg2)/b2))*((1.0 + 1.0/2.0*(((-1) - tanh(((-C4) +
+        (sqrt(Rg2)*q0)/b)/C5))))))/(q04*Rg22);
+
+    yy = ((-1.0*(t1* ((-pow(q0,-p1)*(((b2*pi)/(L*q02) +
+        t2 + t3 - t4 + t5 - t6 + 1.0/2.0*t7*t8)) - b*p1*pow(q0,((-1.0) - p1))*
+        (((-((b*pi)/(L*q0))) + t9 + t10 +
+        1.0/2.0*((C3*pow((((sqrt(Rg2)*q0)/b)),((-3.0)/miu)) +
+        C2*pow((((sqrt(Rg2)*q0)/b)),((-2.0)/miu)) +
+        C1*pow((((sqrt(Rg2)*q0)/b)),((-1.0)/miu))))*
+        ((1.0 + tanh(((-C4) + (sqrt(Rg2)*q0)/b)/C5))))))))));
+
+    return (yy);
+}
+
+//
+static double
+a1short(double q, double L, double b, double p1short, double p2short, double q0)
+{
+    double yy,Rg2_sh;
+    double t1,E,Rg2_sh2,Et1,Emt1,q02,q0p,b3;
+    double pi;
+
+    E = 2.718281828459045091;
+    pi = 4.0*atan(1.0);
+    Rg2_sh = Rgsquareshort(q,L,b);
+    Rg2_sh2 = Rg2_sh*Rg2_sh;
+    b3 = b*b*b;
+    t1 = ((q0*q0*Rg2_sh)/(b*b));
+    Et1 = pow(E,t1);
+    Emt1 =pow(E,-t1);
+    q02 = q0*q0;
+    q0p = pow(q0,(-4.0 + p1short) );
+
+    yy = ((1.0/(L*((p1short - p2short))*Rg2_sh2)*
+        ((b*Emt1*q0p*((8.0*b3*L - 8.0*b3*Et1*L - 2.0*b3*L*p2short +
+        2.0*b3*Et1*L*p2short + 4.0*b*L*q02*Rg2_sh + 4.0*b*Et1*L*q02*Rg2_sh -
+        2.0*b*Et1*L*p2short*q02*Rg2_sh - Et1*pi*q02*q0*Rg2_sh2 +
+        Et1*p2short*pi*q02*q0*Rg2_sh2))))));
+
+    return(yy);
+}
+
+static double
+a2short(double q, double L, double b, double p1short, double p2short, double q0)
+{
+    double yy,Rg2_sh;
+    double t1,E,Rg2_sh2,Et1,Emt1,q02,q0p;
+    double pi;
+
+    E = 2.718281828459045091;
+    pi = 4.0*atan(1.0);
+    Rg2_sh = Rgsquareshort(q,L,b);
+    Rg2_sh2 = Rg2_sh*Rg2_sh;
+    t1 = ((q0*q0*Rg2_sh)/(b*b));
+    Et1 = pow(E,t1);
+    Emt1 =pow(E,-t1);
+    q02 = q0*q0;
+    q0p = pow(q0,(-4.0 + p2short) );
+
+    //E is the number e
+    yy = ((-(1.0/(L*((p1short - p2short))*Rg2_sh2)*
+        ((b*Emt1*q0p*((8.0*b*b*b*L - 8.0*b*b*b*Et1*L - 2.0*b*b*b*L*p1short +
+        2.0*b*b*b*Et1*L*p1short + 4.0*b*L*q02*Rg2_sh + 4.0*b*Et1*L*q02*Rg2_sh -
+        2.0*b*Et1*L*p1short*q02*Rg2_sh - Et1*pi*q02*q0*Rg2_sh2 +
+        Et1*p1short*pi*q02*q0*Rg2_sh2)))))));
+
+    return (yy);
+}
+
+//WR named this w (too generic)
+static double
+w_WR(double x)
+{
+    return 0.5*(1 + tanh((x - 1.523)/0.1477));
+}
+
+//
+static double
+u1(double q, double L, double b)
+{
+    return Rgsquareshort(q,L,b)*q*q;
+}
+
+static double
+u_WR(double q, double L, double b)
+{
+    return Rgsquare(q,L,b)*q*q;
+}
+
+static double
+Sdebye_kernel(double arg)
+{
+    // ORIGINAL
+    double result = 2.0*(exp(-arg) + arg -1.0)/(pow((arg),2));
+
+    // CONVERSION 1 from http://herbie.uwplse.org/
+    //
+    // exhibits discontinuity - needs more investigation
+    //double a1 = 1.0/6.0;
+    //double a2 = 1.0/72.0;
+    //double a3 = 1.0/24.0;
+    //double result = pow((1.0 - a1*arg - (a2+a3)*arg*arg), 2);
+
+    return result;
+}
+static double
+Sdebye(double q, double L, double b)
+{
+    double arg = u_WR(q,L,b);
+    return Sdebye_kernel(arg);
+}
+
+//
+static double
+Sdebye1(double q, double L, double b)
+{
+    double arg = u1(q,L,b);
+    return Sdebye_kernel(arg);
+
+}
+
+//
+static double
+Sexv(double q, double L, double b)
+{
+    double yy,C1,C2,C3,miu,Rg2;
+    C1=1.22;
+    C2=0.4288;
+    C3=-1.651;
+    miu = 0.585;
+
+    Rg2 = Rgsquare(q,L,b);
+
+    yy = (1.0 - w_WR(q*sqrt(Rg2)))*Sdebye(q,L,b) +
+        w_WR(q*sqrt(Rg2))*(C1*pow((q*sqrt(Rg2)),(-1.0/miu)) +
+        C2*pow((q*sqrt(Rg2)),(-2.0/miu)) +
+        C3*pow((q*sqrt(Rg2)),(-3.0/miu)));
+
+    return (yy);
+}
+
+
+static double
+Sexvnew(double q, double L, double b)
+{
+    double yy,C1,C2,C3,miu;
+    double del=1.05,C_star2,Rg2;
+
+    C1=1.22;
+    C2=0.4288;
+    C3=-1.651;
+    miu = 0.585;
+
+    //calculating the derivative to decide on the corection (cutoff) term?
+    // I have modified this from WRs original code
+
+    if( (Sexv(q*del,L,b)-Sexv(q,L,b))/(q*del - q) >= 0.0 ) {
+        C_star2 = 0.0;
+    } else {
+        C_star2 = 1.0;
+    }
+
+    Rg2 = Rgsquare(q,L,b);
+
+    yy = (1.0 - w_WR(q*sqrt(Rg2)))*Sdebye(q,L,b) +
+        C_star2*w_WR(q*sqrt(Rg2))*(C1*pow((q*sqrt(Rg2)),(-1.0/miu)) +
+        C2*pow((q*sqrt(Rg2)),(-2.0/miu)) + C3*pow((q*sqrt(Rg2)),(-3.0/miu)));
+
+    return (yy);
+}
+
+double Sk_WR(double q, double L, double b);
+double Sk_WR(double q, double L, double b)
+{
+  //
+  double p1,p2,p1short,p2short,q0;
+  double C,ans,q0short,Sexvmodify,pi;
+
+  pi = 4.0*atan(1.0);
+
+  p1 = 4.12;
+  p2 = 4.42;
+  p1short = 5.36;
+  p2short = 5.62;
+  q0 = 3.1;
+
+  q0short = fmax(1.9/sqrt(Rgsquareshort(q,L,b)),3.0);
+
+
+  if(L/b > 10.0) {
+    C = 3.06/pow((L/b),0.44);
+  } else {
+    C = 1.0;
+  }
+  //
+
+  //
+  if( L > 4*b ) { // Longer Chains
+    if (q*b <= 3.1) {   //Modified by Yun on Oct. 15,
+
+      Sexvmodify = Sexvnew(q, L, b);
+
+      ans = Sexvmodify + C * (4.0/15.0 + 7.0/(15.0*u_WR(q,L,b)) -
+            (11.0/15.0 + 7.0/(15.0*u_WR(q,L,b)))*exp(-u_WR(q,L,b)))*(b/L);
+
+    } else { //q(i)*b > 3.1
+      ans = a1long(q, L, b, p1, p2, q0)/(pow((q*b),p1)) +
+            a2long(q, L, b, p1, p2, q0)/(pow((q*b),p2)) + pi/(q*L);
+    }
+  } else { //L <= 4*b Shorter Chains
+    if (q*b <= fmax(1.9/sqrt(Rgsquareshort(q,L,b)),3.0) ) {
+      if (q*b<=0.01) {
+        ans = 1.0 - Rgsquareshort(q,L,b)*(q*q)/3.0;
+      } else {
+        ans = Sdebye1(q,L,b);
+      }
+    } else {  //q*b > max(1.9/sqrt(Rgsquareshort(q(i),L,b)),3)
+      ans = a1short(q,L,b,p1short,p2short,q0short)/(pow((q*b),p1short)) +
+            a2short(q,L,b,p1short,p2short,q0short)/(pow((q*b),p2short)) +
+            pi/(q*L);
+    }
+  }
+
+  return(ans);
+}
Index: sasmodels/models/linear_pearls.c
===================================================================
--- sasmodels/models/linear_pearls.c	(revision 577912b439fe119a0663629c075b6b67323269ca)
+++ sasmodels/models/linear_pearls.c	(revision 577912b439fe119a0663629c075b6b67323269ca)
@@ -0,0 +1,123 @@
+double form_volume(double radius, double num_pearls);
+
+double Iq(double q,
+            double radius,
+            double edge_sep,
+            double num_pearls,
+            double pearl_sld,
+            double solvent_sld);
+
+double Iqxy(double qx, double qy,
+            double radius,
+            double edge_sep,
+            double num_pearls,
+            double pearl_sld,
+            double solvent_sld);
+
+double linear_pearls_kernel(double q,
+            double radius,
+            double edge_sep,
+            double num_pearls,
+            double pearl_sld,
+            double solvent_sld);
+
+
+double form_volume(double radius, double num_pearls)
+{
+    // Pearl volume
+    double pearl_vol = 4.0 /3.0 * M_PI * pow(radius, 3.0);
+    // Return total volume
+    return num_pearls * pearl_vol;;
+}
+
+// If used elsewhere - factor out to lib/
+static
+double sinc(double x)
+{
+  if (x==0.0){
+    return 1.0;
+  }
+  return sin(x)/x;
+}
+
+double linear_pearls_kernel(double q,
+            double radius,
+            double edge_sep,
+            double num_pearls,
+            double pearl_sld,
+            double solvent_sld)
+{
+    double n_contrib;
+    //relative sld
+    double contrast_pearl = pearl_sld - solvent_sld;
+    //each volume
+    double pearl_vol = 4.0 /3.0 * M_PI * pow(radius, 3.0);
+    //total volume
+    double tot_vol = num_pearls * pearl_vol;
+    //mass
+    double m_s = contrast_pearl * pearl_vol;
+    //center to center distance between the neighboring pearls
+    double separation = edge_sep + 2.0 * radius;
+
+    double x=q*radius;
+
+    // Try Taylor on x*xos(x)
+	// double out_cos = x - pow(x,3)/2 + pow(x,5)/24 - pow(x,7)/720 + pow(x,9)/40320;
+    // psi -= x*out_cos;
+
+    //sine functions of a pearl
+    double psi = sin(q * radius);
+    psi -= x * cos(x);
+    psi /= pow((q * radius), 3.0);
+
+    // N pearls contribution
+    int n_max = num_pearls - 1;
+    n_contrib = num_pearls;
+    for(int num=1; num<=n_max; num++) {
+        n_contrib += (2.0*(num_pearls-num)*sinc(q*separation*num));
+    }
+    // form factor for num_pearls
+    double form_factor = n_contrib;
+    form_factor *= pow((m_s*psi*3.0), 2.0);
+    form_factor /= (tot_vol * 1.0e4);
+
+    return form_factor;
+}
+
+double Iq(double q,
+            double radius,
+            double edge_sep,
+            double num_pearls,
+            double pearl_sld,
+            double solvent_sld)
+{
+
+	double result = linear_pearls_kernel(q,
+                    radius,
+                    edge_sep,
+                    num_pearls,
+                    pearl_sld,
+                    solvent_sld);
+
+	return result;
+}
+
+double Iqxy(double qx, double qy,
+            double radius,
+            double edge_sep,
+            double num_pearls,
+            double pearl_sld,
+            double solvent_sld)
+{
+	double q;
+	q = sqrt(qx*qx+qy*qy);
+
+	double result = linear_pearls_kernel(q,
+                    radius,
+                    edge_sep,
+                    num_pearls,
+                    pearl_sld,
+                    solvent_sld);
+
+	return result;
+}
Index: sasmodels/models/linear_pearls.py
===================================================================
--- sasmodels/models/linear_pearls.py	(revision 577912b439fe119a0663629c075b6b67323269ca)
+++ sasmodels/models/linear_pearls.py	(revision 577912b439fe119a0663629c075b6b67323269ca)
@@ -0,0 +1,110 @@
+r"""
+This model provides the form factor for $N$ spherical pearls of radius $R$
+linearly joined by short strings (or segment length or edge separation)
+$l$ $(= A - 2R)$. $A$ is the center-to-center pearl separation distance.
+The thickness of each string is assumed to be negligible.
+
+.. figure:: img/linear_pearls_fig1.jpg
+
+
+Definition
+----------
+
+The output of the scattering intensity function for the linear_pearls model
+is given by (Dobrynin, 1996)
+
+.. math::
+
+    P(Q) = \frac{scale}{V}\left[ m_{p}^2
+    \left(N+2\sum_{n-1}^{N-1}(N-n)\frac{sin(qnl)}{qnl}\right)
+    \left( 3\frac{sin(qR)-qRcos(qR)}{(qr)^3}\right)^2\right]
+
+where the mass $m_p$ is $(SLD_{pearl}-SLD_{solvent})*(volume\ of\ N\ pearls)$.
+V is the total volume.
+
+The 2D scattering intensity is the same as P(q) above,
+regardless of the orientation of the q vector.
+
+.. figure:: img/linear_pearls_1d.jpg
+
+    1D plot using the default values (w/500 data point).
+
+References
+----------
+
+A V Dobrynin, M Rubinstein and S P Obukhov, *Macromol.*,
+29 (1996) 2974-2979
+
+"""
+
+from numpy import inf
+
+name = "linear_pearls"
+title = "Linear pearls model of scattering from spherical pearls."
+description = """
+    Calculate form factor for Pearl Necklace Model
+    [Macromol. 1996, 29, 2974-2979]
+    Parameters:
+
+    sld_pearl: the SLD of the pearl spheres
+    sld_solv: the SLD of the solvent
+    num_pearls: number of the pearls
+    radius: the radius of a pearl
+    edge_separation: the length of string segment; surface to surface
+    """
+category = "shape:sphere"
+
+# pylint: disable=bad-whitespace, line-too-long
+#            ["name", "units", default, [lower, upper], "type", "description"],
+parameters = [
+    ["radius",      "Ang",       80.0, [0, inf],     "", "Radius of the pearls"],
+    ["edge_sep",    "Ang",      350.0, [0, inf],     "", "Length of the string segment - surface to surface"],
+    ["num_pearls",  "",           3.0, [0, inf],     "", "Number of the pearls"],
+    ["pearl_sld",   "1e-6/Ang^2", 1.0, [-inf, inf],  "", "SLD of the pearl spheres"],
+    ["solvent_sld", "1e-6/Ang^2", 6.3, [-inf, inf],  "", "SLD of the solvent"],
+    ]
+# pylint: enable=bad-whitespace, line-too-long
+
+source = ["linear_pearls.c"]
+
+demo = dict(scale=1.0, background=0.0,
+            radius=80.0,
+            edge_sep=350.0,
+            num_pearls=3,
+            pearl_sld=1.0,
+            solvent_sld=6.3)
+
+oldname = "LinearPearlsModel"
+
+oldpars = dict(edge_sep='edge_separation',
+               pearl_sld='sld_pearl',
+               solvent_sld='sld_solv')
+
+"""
+Tests temporarily disabled, until single-double precision accuracy issue solved.
+
+tests = [
+    # Accuracy tests based on content in test/utest_model_pearlnecklace.py
+    [{'radius':      20.0,
+      'num_pearls':   2.0,
+      'pearl_sld':    1.0,
+      'solvent_sld':  6.3,
+      'edge_sep':   400.0,
+     }, 0.001, 185.135],
+
+    # Additional tests with larger range of parameters
+    [{'radius':     120.0,
+      'num_pearls':   5.0,
+      'pearl_sld':    2.0,
+      'solvent_sld':  2.3,
+      'edge_sep':   100.0,
+     }, 0.01, 45.4984],
+
+    [{'radius':       7.0,
+      'num_pearls':   2.0,
+      'pearl_sld':   10.0,
+      'solvent_sld': 99.3,
+      'edge_sep':    20.0,
+     }, 1.0, 0.632811],
+    ]
+"""
Index: sasmodels/models/mass_fractal.py
===================================================================
--- sasmodels/models/mass_fractal.py	(revision 9c461c713e9961727442c844be3e6354d6548c2f)
+++ sasmodels/models/mass_fractal.py	(revision 168052c5791506d7dfad00173f5636fc5701ad11)
@@ -52,5 +52,6 @@
 ---------
 
-D Mildner and P Hall, *J. Phys. D: Appl. Phys.*,  19 (1986) 1535-1545 Equation(9)
+D Mildner and P Hall, *J. Phys. D: Appl. Phys.*,
+19 (1986) 1535-1545 Equation(9)
 
 
@@ -79,10 +80,11 @@
 category = "shape-independent"
 
+# pylint: disable=bad-whitespace, line-too-long
 #             ["name", "units", default, [lower, upper], "type","description"],
 parameters = [["radius",        "Ang",  10.0, [0.0, inf], "", "Particle radius"],
               ["mass_dim",      "",      1.9, [1.0, 6.0], "", "Mass fractal dimension"],
               ["cutoff_length", "Ang", 100.0, [0.0, inf], "", "Cut-off length"],
-              ]
-
+             ]
+# pylint: enable=bad-whitespace, line-too-long
 
 source = ["lib/sph_j1c.c", "lib/lanczos_gamma.c", "mass_fractal.c"]
@@ -91,5 +93,5 @@
             radius=10.0,
             mass_dim=1.9,
-            cutoff_length=2.3)
+            cutoff_length=100.0)
 
 oldname = 'MassFractalModel'
@@ -98,19 +100,28 @@
                cutoff_length='co_length')
 
-tests = [[{'radius':        2.0,
-           'mass_dim':      3.3,
-           'cutoff_length': 1.0,
-           }, 0.5, 1.29016774904],
+tests = [
 
-         [{'radius':        1.0,
-           'mass_dim':      1.3,
-           'cutoff_length': 1.0,
-           'background':    0.8,
-           }, 0.001, 1.69747015932],
+    # Accuracy tests based on content in test/utest_other_models.py
+    [{'radius':         10.0,
+      'mass_dim':        1.9,
+      'cutoff_length': 100.0,
+     }, 0.05, 279.59322],
 
-         [{'radius':        1.0,
-           'mass_dim':      2.3,
-           'cutoff_length': 1.0,
-           'scale':        10.0,
-           }, 0.051, 11.6227966145],
-         ]
+    # Additional tests with larger range of parameters
+    [{'radius':        2.0,
+      'mass_dim':      3.3,
+      'cutoff_length': 1.0,
+     }, 0.5, 1.29016774904],
+
+    [{'radius':        1.0,
+      'mass_dim':      1.3,
+      'cutoff_length': 1.0,
+      'background':    0.8,
+     }, 0.001, 1.69747015932],
+
+    [{'radius':        1.0,
+      'mass_dim':      2.3,
+      'cutoff_length': 1.0,
+      'scale':        10.0,
+     }, 0.051, 11.6227966145],
+    ]
